## hurd 0.9.git20251029

=== Makefile ===
#
#   Copyright (C) 1993-1999, 2001, 2002, 2004, 2006, 2009,
#   2011-2013, 2015-2019 Free Software Foundation, Inc.
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

dir := .
makemode := misc

DISTFILES := configure

include ./Makeconf

## Subdirectories of this directory should all be mentioned here

# Hurd libraries
lib-subdirs = libshouldbeinlibc libihash libiohelp libports \
	      libpager libfshelp libdiskfs libtrivfs libps \
	      libnetfs libpipe libstore libhurdbugaddr libftpconn libcons \
	      libhurd-slab \
	      libbpf \
	      libmachdev \
	      libirqhelp \

# Hurd programs
prog-subdirs = auth proc exec term \
	       ext2fs isofs tmpfs fatfs \
	       storeio pflocal pfinet defpager mach-defpager \
	       login daemons boot console \
	       hostmux usermux ftpfs trans \
	       console-client utils sutils libfshelp-tests \
	       benchmarks fstests \
	       procfs \
	       startup \
	       init \
	       devnode \
	       eth-multiplexer \
	       shutdown \
	       rtc

ifeq ($(HAVE_LIBRUMP),yes)
prog-subdirs += rumpdisk rumpnet
endif

ifeq ($(HAVE_SUN_RPC),yes)
prog-subdirs += nfs nfsd
endif

ifeq ($(HAVE_LIBLWIP),yes)
prog-subdirs += lwip
endif

ifeq ($(HAVE_LIBPCIACCESS),yes)
prog-subdirs += pci-arbiter
endif

ifeq ($(HAVE_LIBACPICA),yes)
prog-subdirs += acpi
endif

# Other directories
other-subdirs = hurd doc config release include

# All the subdirectories together
subdirs = $(lib-subdirs) $(prog-subdirs) $(other-subdirs)

# This allows the creation of a file BROKEN in any of the prog-subdirs;
# that will prevent this top level Makefile from attempting to make it.
working-prog-subdirs := $(filter-out \
			  $(patsubst %/,%,\
				 $(dir $(wildcard $(prog-subdirs:=/BROKEN)))),\
			  $(prog-subdirs))


$(subdirs): version.h

## GNU Coding Standards targets (not all are here yet), and some other
## similar sorts of things

all: $(lib-subdirs) $(working-prog-subdirs)

# Create a distribution tar file.

git_describe := git describe --match '*release*'
dist-version := $(shell cd $(top_srcdir)/ && $(git_describe))

.PHONY: dist
ifdef configured
dist: $(foreach Z,xz gz,$(dist-version).tar.$(Z))
else
dist:
	@echo >&2 'Cannot build a distribution from an unconfigured tree.'
	false
endif

HEAD.tar: FORCE
	cd $(top_srcdir)/ && git status --short \
	  | $(AWK) '{ print; rc=1 } END { exit rc }' \
	  || { echo >&2 \
		'Refusing to build a distribution from dirty sources.' && \
		false; }
	(cd $(top_srcdir)/ && git archive --prefix=$(dist-version)/ HEAD) > $@

ChangeLog.tar: gen-ChangeLog
	tar -c -f $@ --owner=0 --group=0 \
	  --transform='s%^%$(dist-version)/%' $(ChangeLog_files)

# See the ChangeLog file.
gitlog-to-changelog_rev = \
  2772f5c6a6a51cf946fd95bf6ffe254273157a21..
ChangeLog_files = \
  $(filter-out :%,$(subst :, :,$(ChangeLog_specs)))
ChangeLog_specs = \
  ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  auth/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  benchmarks/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  boot/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  config/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  console-client/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  console/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  daemons/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  defpager/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  doc/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  exec/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  ext2fs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  fatfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  fstests/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  ftpfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  hostmux/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  hurd/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  include/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  init/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  isofs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libcons/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libdirmgt/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libdiskfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libfshelp/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libftpconn/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libhurdbugaddr/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libihash/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libiohelp/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libnetfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libpager/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libpipe/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libports/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libps/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libshouldbeinlibc/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libstore/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libthreads/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libtrivfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  login/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  mach-defpager/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  nfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  nfsd/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  pfinet/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  pflocal/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  proc/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  release/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  storeio/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  sutils/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  term/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  tmpfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  trans/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  usermux/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  utils/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21
# procfs
gitlog-to-changelog_rev += \
  ^aac4aaf42372f61c78061711916c81a9d5bcb42d~1
ChangeLog_specs += \
  procfs/ChangeLog:edb4593c38d421b5d538b221a991b50c36fdba15:ChangeLog
# random
gitlog-to-changelog_rev += \
  ^1ba2ed95690396bf081d0af043d878b26b8563c2~1
# Specify dummy ChangeLog file, will get overwritten.
ChangeLog_specs += \
  random/ChangeLog:HEAD:ChangeLog
.PHONY: gen-ChangeLog
gen-ChangeLog:
	$(AM_V_GEN)if test -d $(top_srcdir)/.git; then			\
	  rm -f $(ChangeLog_files) &&					\
	  (cd $(top_srcdir)/ &&						\
	  ./gitlog-to-changelog	--strip-tab				\
	    $(gitlog-to-changelog_rev) &&				\
	  echo) >> ChangeLog &&						\
	  (cd $(top_srcdir)/ &&						\
	  ./gitlog-to-changelog --strip-tab				\
	    edb4593c38d421b5d538b221a991b50c36fdba15..aac4aaf42372f61c78061711916c81a9d5bcb42d~1 && \
	  echo) >> procfs/ChangeLog &&					\
	  rm -f random/ChangeLog-1 &&					\
	  (cd $(top_srcdir)/ &&						\
	  ./gitlog-to-changelog --strip-tab				\
	    ac38884dc9ad32a11d09f55ba9fe399cd0a48e2f..1ba2ed95690396bf081d0af043d878b26b8563c2~1 && \
	  echo) >> random/ChangeLog-1 &&				\
	  for cs in $(ChangeLog_specs); do				\
	    f=$${cs%%:*} &&						\
	    s=$${cs#$$f:} && s_f=$$s:$$f && s=$${s_f/*:*:*/$$s} &&	\
	    (cd $(top_srcdir)/ &&					\
	    git show $$s) >> $$f					\
	    || exit $$?;						\
	  done &&							\
	  rm -f random/ChangeLog_ &&					\
	  (cd $(top_srcdir)/ &&						\
	  git ls-tree --name-only					\
	    ac38884dc9ad32a11d09f55ba9fe399cd0a48e2f) >> random/ChangeLog_ && \
	  rm -f random/ChangeLog-2 &&					\
	  perl \
	    -e 'print "2011-08-18  Gaël Le Mignot  <kilobug\@freesurf.fr>\n\n"; while(<>){s%^%\t* %;s%$$%: New file.%;print;}' \
	    < random/ChangeLog_ > random/ChangeLog-2 &&			\
	  cat random/ChangeLog-* > random/ChangeLog &&			\
	  rm random/ChangeLog?* &&					\
	  sed								\
	    -e 's%\* [ ]*%* procfs/%'					\
	    -e s%procfs/procfs/%procfs/%				\
	    -i procfs/ChangeLog &&					\
	  sed								\
	    -e 's%\* [ ]*%* random/%'					\
	    -i random/ChangeLog;					\
	fi

$(dist-version).tar: HEAD.tar $(addsuffix /dist-hook,hurd/.. $(subdirs)) ChangeLog.tar
	tar -c -f $@ --files-from=/dev/null
# Concatenate the tar files.  Have
# to do it one by one: <http://savannah.gnu.org/patch/?7757>.
	for f in HEAD.tar dist.tar */dist.tar ChangeLog.tar; do \
	  tar -v --concatenate -f $@ "$$f"; \
	done

clean: $(addsuffix -clean,$(subdirs)) clean-misc

relink: $(addsuffix -relink,$(lib-subdirs) $(prog-subdirs))

objs: $(addsuffix -objs,$(lib-subdirs) $(prog-subdirs))

install: $(addsuffix -install,$(lib-subdirs) $(working-prog-subdirs) \
	   $(other-subdirs))

install-headers: $(addsuffix -install-headers,$(lib-subdirs) \
		$(working-prog-subdirs)\
		$(other-subdirs))

TAGS: $(addsuffix -TAGS,$(working-prog-subdirs) $(lib-subdirs))
	etags -o $@ $(patsubst %-TAGS,-i %/TAGS,$^)

%.xz: %
	xz < $< > $@

%.gz: %
	gzip -9n < $< > $@

## Targets used by the main targets above.
$(prog-subdirs) $(lib-subdirs): FORCE
	$(MAKE) -C $@ all
FORCE:

%-clean:
	$(MAKE) -C $* clean no_deps=t

%-relink:
	$(MAKE) -C $* relink no_deps=t

%-objs:
	$(MAKE) -C $* objs

%-install:
	$(MAKE) -C $* install

%-install-headers:
	$(MAKE) -C $* install-headers

%-TAGS:
	$(MAKE) -C $* TAGS no_deps=t

.PHONY: %/dist-hook
%/dist-hook:
	$(MAKE) -C $* dist-hook no_deps=t dist-version=$(dist-version)

.PHONY: clean-misc distclean
clean-misc:
	rm -f HEAD.tar ChangeLog.tar $(ChangeLog_files)

distclean: clean
	rm -f config.make config.log config.status config.cache
ifneq (.,${srcdir})
	rm -f Makefile
endif


## Directory dependencies
#
# Some directories depend on others, so we need to find out exactly
# what they are.  This does that for us.

ifneq ($(no_deps),t)
-include $(addsuffix .d,$(subdirs))
endif

# How to build them
$(addsuffix .d,$(subdirs)): %.d: $(top_srcdir)/%/Makefile
	$(MAKE) -C $* directory-depend no_deps=t


## Build system

AUTOCONF = autoconf
AUTOCONF_FLAGS = -I $(top_srcdir)

$(top_srcdir)/configure: $(top_srcdir)/configure.ac $(top_srcdir)/aclocal.m4
	$(AUTOCONF) $(AUTOCONF_FLAGS) $< > $@
	chmod +x $@

config.status: $(top_srcdir)/configure
	$(SHELL) $@ --recheck

config.make: config.status $(top_srcdir)/config.make.in
# No stamp file is used here, as config.make's timestamp changing will not have
# any far-reaching consequences.
	$(SHELL) $< --file=$@

version.h: stamp-version; @:
stamp-version: version.h.in config.make
	sed -e 's/MASTER_HURD_VERSION/\"$(package-version)\"/' \
	  < $< > version.h.new
	$(move-if-change) version.h.new version.h
	touch $@

=== acpi/Makefile ===
#   Copyright (C) 2018 Free Software Foundation, Inc.
#
#   This file is part of the GNU Hurd.
#
#   The GNU Hurd is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   The GNU Hurd is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with the GNU Hurd.  If not, see <<a rel="nofollow" href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>>.

dir            = acpi
makemode       = server

PORTDIR = $(srcdir)/port

SRCS           = main.c netfs_impl.c acpi.c \
                 acpifs.c ncache.c options.c func_files.c acpi-ops.c \
                 acpiServer.c startup_notifyServer.c

MIGSRCS        =
OBJS           = $(patsubst %.S,%.o,$(patsubst %.c,%.o, $(SRCS) $(MIGSRCS)))

HURDLIBS= fshelp ports shouldbeinlibc netfs iohelp ihash machdev trivfs irqhelp
LDLIBS = -lpthread $(libacpica_LIBS)

target = acpi acpi.static

include ../Makeconf

CFLAGS += -I$(PORTDIR)/include $(libacpica_CFLAGS)

acpi-MIGSFLAGS = -imacros $(srcdir)/mig-mutate.h

# cpp doesn't automatically make dependencies for -imacros dependencies. argh.
acpi_S.h acpiServer.c: mig-mutate.h

=== benchmarks/Makefile ===
# 
#   Copyright (C) 1994, 1995 Free Software Foundation
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

dir := benchmarks
makemode := utility

SRCS = forks.c
OBJS = forks.o
target = forks

include ../Makeconf

=== boot/Makefile ===
# Copyright (C) 1993,94,95,96,97,2001,2012 Free Software Foundation, Inc.
# This file is part of the GNU Hurd.
#
# The GNU Hurd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GNU Hurd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the GNU Hurd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

dir := boot
makemode := utility

SRCS = boot.c boot_script.c userland-boot.c
COMMON-OBJS = notifyServer.o deviceServer.o \
       ioServer.o io_replyUser.o device_replyUser.o \
       termServer.o boot_script.o userland-boot.o
MIGSTUBS = machServer.o mach_hostServer.o gnumachServer.o task_notifyServer.o
OBJS = boot.o $(COMMON-OBJS) $(MIGSTUBS)
target = boot
MIGSFLAGS=-imacros $(srcdir)/mig-mutate.h -DHURD_DEFAULT_PAYLOAD_TO_PORT=1
device-MIGSFLAGS=-DDEVICE_ENABLE_DEVICE_OPEN_NEW
io-MIGSFLAGS=-DREPLY_PORTS -DHURD_DEFAULT_PAYLOAD_TO_PORT=1
HURDLIBS = store shouldbeinlibc ihash
LDLIBS += -lpthread

include ../Makeconf

=== config/Makefile ===
#   Copyright (C) 1996, 1997, 1999, 2004, 2012 Free Software Foundation, Inc.
#   Written by Michael I. Bushnell, p/BSG.
#
#   This file is part of the GNU Hurd.
#
#   The GNU Hurd is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   The GNU Hurd is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.

dir := config
makemode := misc

# Files that are copied verbatim to $(sysconfdir).  But we never want
# to overwrite an existing file.  Print a warning for such files.
# If override_conf is set to `t' then install even on top of existing
# files.
SYSCONFFILES = motd ttys

installed_conf = $(addprefix $(sysconfdir)/,$(SYSCONFFILES))

LOGINDOTS = .bash_login .bashrc .hushlogin .profile README
installed_logins = $(addprefix $(sysconfdir)/login/,$(LOGINDOTS))

FORCE:

ifeq ($(override_conf),t)
$(installed_conf): FORCE
$(installed_logins): FORCE
endif

include ../Makeconf

install: $(DESTDIR)$(sysconfdir) $(DESTDIR)$(sysconfdir)/login \
	 $(addprefix $(DESTDIR),$(installed_conf)) $(addprefix $(DESTDIR),$(installed_logins))

$(DESTDIR)$(sysconfdir)/login: %:
	mkdir -p $@

$(addprefix $(DESTDIR),$(installed_logins)): $(DESTDIR)$(sysconfdir)/login/%: login-%
	$(INSTALL_DATA) $< $(DESTDIR)$(sysconfdir)/login/$*

$(addprefix $(DESTDIR),$(installed_conf)): $(DESTDIR)$(sysconfdir)/%: %
	$(INSTALL_DATA) $< $(DESTDIR)$(sysconfdir)/$*

cleantarg += ttys
ttys: ttys.in
	sed -e 's:@libexecdir@:'$(libexecdir)':g' < $< > $@

=== console-client/Makefile ===
#
#   Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2004,
#   2005, 2008, 2010, 2011, 2012, 2013, 2014, 2015, 2016 Free Software
#   Foundation, Inc.
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

dir := console-client
makemode := utilities

targets = console
CONSOLE_SRCS = console.c timer.c driver.c trans.c
VGA_SO_SRCS = bdf.c vga-dynafont.c vga-dynacolor.c vga-support.c vga.c fb.c
PC_KBD_SO_SRCS = pc-kbd.c kbd-repeat.c
PC_MOUSE_SO_SRCS = pc-mouse.c
GENERIC_SPEAKER_SO_SRCS = generic-speaker.c
CURRENT_VCS_SO_SRCS = current-vcs.c
SRCS = $(CONSOLE_SRCS) \
  $(VGA_SO_SRCS) $(PC_KBD_SO_SRCS) $(PC_MOUSE_SO_SRCS) \
  $(GENERIC_SPEAKER_SO_SRCS) $(CURRENT_VCS_SO_SRCS) $(XKB_SRCS)

VPATH += $(srcdir)/xkb
OBJS = $(addsuffix .o,$(basename $(notdir $(SRCS)))) kdioctlServer.o
HURDLIBS = cons ports netfs fshelp iohelp ihash shouldbeinlibc
LDLIBS = -ldl -lpthread $(libdaemon_LIBS)
module-dir = $(libdir)/hurd/console
console-LDFLAGS = -Wl,-E

CPPFLAGS += -I$(CURDIR)/xkb -I$(srcdir)/xkb $(libdaemon_CFLAGS)
LFLAGS = -i
XKB_DATA_FILES = keymap/hurd types/hurd symbols/hurd

# In seeking, thou shalt find it!
CPPFLAGS += -DQUAERENDO_INVENIETIS

include ../Makeconf

driver-CPPFLAGS = -D'CONSOLE_DEFPATH="$(module-dir)\0"' \
	-D'CONSOLE_SONAME_SUFFIX=".so.$(hurd-version)"'
driver-DEPS = $(..)config.make

console: $(CONSOLE_SRCS:.c=.o) \
	../libcons/libcons.a ../libfshelp/libfshelp.a \
	../libnetfs/libnetfs.a ../libiohelp/libiohelp.a \
	../libihash/libihash.a ../libports/libports.a \
	../libshouldbeinlibc/libshouldbeinlibc.a

modules = vga pc_kbd generic_speaker pc_mouse current_vcs

vga-CPPFLAGS = -DDEFAULT_VGA_FONT_DIR=\"${datadir}/hurd/\"
fb-CPPFLAGS = -DDEFAULT_VGA_FONT_DIR=\"${datadir}/hurd/\"
vga-support-CFLAGS = -minline-all-stringops
vga.so.$(hurd-version): $(patsubst %.c,%_pic.o,$(VGA_SO_SRCS))
pc_kbd.so.$(hurd-version): $(patsubst %.c,%_pic.o,$(PC_KBD_SO_SRCS)) \
	kdioctlServer_pic.o
pc_mouse.so.$(hurd-version): $(patsubst %.c,%_pic.o,$(PC_MOUSE_SO_SRCS))
generic_speaker.so.$(hurd-version): $(patsubst %.c,%_pic.o,$(GENERIC_SPEAKER_SO_SRCS))
current_vcs.so.$(hurd-version): $(patsubst %.c,%_pic.o,$(CURRENT_VCS_SO_SRCS))

ifneq ($(LIBNCURSESW),)
NCURSESW_SO_SRCS = ncursesw.c
SRCS += $(NCURSESW_SO_SRCS)
modules += ncursesw
ncursesw.so.$(hurd-version): $(patsubst %.c,%_pic.o,$(NCURSESW_SO_SRCS))
ncursesw-CPPFLAGS = $(NCURSESW_INCLUDE)
ncursesw-LDLIBS = $(LIBNCURSESW)
endif

all: $(addsuffix .so.$(hurd-version), $(modules))

cleantarg += $(addsuffix .so.$(hurd-version), $(modules))

install: $(DESTDIR)$(module-dir) $(addprefix $(DESTDIR)$(module-dir)/,$(addsuffix .so.$(hurd-version),$(modules)))

$(DESTDIR)$(module-dir):
	@$(MKINSTALLDIRS) $@

$(DESTDIR)$(module-dir)/%: %
	$(INSTALL_DATA) $< $@

# You can use this rule to make a dynamically-loadable version of any
# of the modules.
%.so.$(hurd-version): 
	$(CC) -shared -Wl,-soname=$@ -o $@ $(lpath) \
		$(CFLAGS) $($*-CFLAGS) $(LDFLAGS) \
		$^ '-Wl,-(' $($*-LDLIBS) '-Wl,-)'

XKB_SRCS =
ifeq ($(HAVE_XKBCOMMON),yes)
XKB_SRCS = xkb/xkb.c xkb/xkbtimer.c
XKB_UNITS = $(basename $(notdir $(XKB_SRCS)))
pc_kbd.so.$(hurd-version): $(addsuffix _pic.o,$(XKB_UNITS))
pc-kbd-CFLAGS = -DXKB_SUPPORT $(XKBCOMMON_CFLAGS)
$(foreach XKB_UNIT, $(XKB_UNITS), $(eval $(XKB_UNIT)-CFLAGS = $(XKBCOMMON_CFLAGS)))
pc_kbd-LDLIBS = $(XKBCOMMON_LIBS)
endif

=== console/Makefile ===
#   Copyright (C) 2002, 2012 Free Software Foundation, Inc.
#   Written by Marcus Brinkmann.
#
#   This file is part of the GNU Hurd.
#
#   The GNU Hurd is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   The GNU Hurd is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.

dir := console
makemode := server

target = console

SRCS = console.c display.c pager.c input.c

MIGSTUBS = notifyServer.o tioctlServer.o fs_notifyUser.o

HURDLIBS = netfs fshelp iohelp pager ports ihash shouldbeinlibc
LDLIBS = -lpthread
OBJS = $(sort $(SRCS:.c=.o) $(MIGSTUBS))

MIGSFLAGS += -imacros $(srcdir)/mutations.h

# This is the old monolithic version of the console server.
#SRCS = main.c vcons.c focus.c vga-display.c vga.c dynafont.c bdf.c
#
#HURDLIBS = trivfs fshelp iohelp threads ports ihash shouldbeinlibc
#OBJS = $(subst .c,.o,$(SRCS)) tioctlServer.o
#
#MIGSFLAGS += -imacros $(srcdir)/mutations.h

include ../Makeconf

=== daemons/Makefile ===
# Makefile for daemons
#
#   Copyright (C) 1996, 1999, 2008, 2010 Free Software Foundation, Inc.
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

dir := daemons
makemode := utilities

targets = rc getty mail.local console-run runttys runsystem runsystem.hurd
special-targets = rc runsystem runsystem.hurd
SRCS = rc.sh runsystem.sh getty.c lmail.c console-run.c runttys.c \
	runsystem.hurd.sh \

installationdir = $(libexecdir)

HURDLIBS = fshelp ports shouldbeinlibc
OBJS = $(SRCS:.c=.o)
getty-LDLIBS = -lutil

INSTALL-mail.local-ops = -o root -m 4755

include ../Makeconf

rc: rc.sh
getty: getty.o ../libshouldbeinlibc/libshouldbeinlibc.a
mail.local: lmail.o ../libshouldbeinlibc/libshouldbeinlibc.a
console-run: console-run.o ../libfshelp/libfshelp.a ../libports/libports.a \
	../libihash/libihash.a ../libshouldbeinlibc/libshouldbeinlibc.a

runttys: runttys.o ../libshouldbeinlibc/libshouldbeinlibc.a
runttys-LDLIBS = -lutil

runsystem: runsystem.sh
runsystem.hurd: runsystem.hurd.sh

=== defpager/Makefile ===
# 
#   Copyright (C) 1995, 1996 Free Software Foundation
#   Written by Michael I. Bushnell.
#
#   This file is part of the GNU Hurd.
#
#   The GNU Hurd is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   The GNU Hurd is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

dir := defpager
makemode := misc

SRCS = defpager.c

subst-functions=__syscall_vm_allocate syscall_vm_allocate \
		__vm_allocate_rpc vm_allocate_rpc \
		__syscall_vm_map syscall_vm_map \
		__vm_map_rpc vm_map_rpc
comma=,
LDFLAGS=-Wl,$(subst :,$(comma),$(strip $(subst-functions)))

include ../Makeconf

=== devnode/Makefile ===
# Copyright (C) 1992, 1993, 1994, 1995, 1996, 2008 Free Software Foundation, Inc.
# This file is part of the GNU Hurd.
#
# The GNU Hurd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GNU Hurd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the GNU Hurd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

dir := devnode
makemode := server

SRCS = devnode.c
LCLHDRS = util.h
HURDLIBS = fshelp ihash iohelp ports shouldbeinlibc trivfs
target = devnode
MIGSTUBS = deviceServer.o notifyServer.o
MIGSFLAGS = -imacros $(srcdir)/mig-mutate.h
device-MIGSFLAGS=-DMACH_PAYLOAD_TO_PORT=ports_payload_get_name -DDEVICE_ENABLE_DEVICE_OPEN_NEW
OBJS = $(SRCS:.c=.o) $(MIGSTUBS)

include ../Makeconf

=== eth-multiplexer/Makefile ===
# Copyright (C) 1992, 1993, 1994, 1995, 1996, 2008 Free Software Foundation, Inc.
# This file is part of the GNU Hurd.
#
# The GNU Hurd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GNU Hurd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the GNU Hurd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

dir := eth-multiplexer
makemode := server
target = eth-multiplexer

#CFLAGS += -DDEBUG
SRCS = ethernet.c vdev.c multiplexer.c dev_stat.c netfs_impl.c device_impl.c dead-name.c demuxer.c
MIGSTUBS = deviceServer.o
MIGSFLAGS = -imacros $(srcdir)/mig-mutate.h
device-MIGSFLAGS=-DMACH_PAYLOAD_TO_PORT=ports_payload_get_name -DDEVICE_ENABLE_DEVICE_OPEN_NEW
OBJS = $(SRCS:.c=.o) $(MIGSTUBS)
LCLHDRS = ethernet.h util.h vdev.h netfs_impl.h
HURDLIBS = ports ihash iohelp fshelp shouldbeinlibc netfs bpf
LDLIBS = -lpthread

CFLAGS += -I$(top_srcdir)/libbpf

include ../Makeconf

=== exec/Makefile ===
# Copyright (C) 1993,94,95,96,98,99,2000,01,02,10,12 Free Software Foundation,
# Inc.
#
# This file is part of the GNU Hurd.
#
# The GNU Hurd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GNU Hurd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the GNU Hurd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

dir := exec
makemode := server

SRCS = exec.c main.c hashexec.c hostarch.c
OBJS = main.o hostarch.o exec.o hashexec.o \
       execServer.o exec_startupServer.o

target = exec exec.static
HURDLIBS = trivfs fshelp iohelp ports ihash shouldbeinlibc
LDLIBS = -lpthread

exec-MIGSFLAGS = -imacros $(srcdir)/execmutations.h
exec_startup-MIGSFLAGS = -imacros $(srcdir)/execmutations.h

include ../Makeconf

exec.static exec: $(OBJS) $(library_deps)

=== debian/changelog ===
hurd (1:0.9.git20251029-6) unstable; urgency=medium

  * patches/git-in_pktinfo2: Fix build against glibc 2.42.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 15 Feb 2026 08:35:28 +0100

hurd (1:0.9.git20251029-5) unstable; urgency=medium

  * patches/git-in_pktinfo: Fix build against glibc 2.43.
  * patches/git-linux-glibc-2.43: Fix build against glibc 2.43.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 15 Feb 2026 00:59:12 +0000

hurd (1:0.9.git20251029-4) unstable; urgency=medium

  * control: Add libcrypt-dev build dependency to get crypt.h

 -- Samuel Thibault <sthibault@debian.org>  Sun, 08 Feb 2026 18:54:44 +0100

hurd (1:0.9.git20251029-3) unstable; urgency=medium

  * patches/rpctrace-time: Add -t option to rpctrace for timestamps.
  * patches/cthreads.patch: Drop, not needed any more.
  * rules: preseed presence of mach_port_set_ktype.
  * patches/exists: MAKEDEV: Avoid starting passive translators.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 08 Feb 2026 00:42:34 +0100

hurd (1:0.9.git20251029-2) unstable; urgency=medium

  * patches/git-ucd0: MAKEDEV: Fix supporting ucd0.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 03 Nov 2025 19:13:42 +0100

hurd (1:0.9.git20251029-1) unstable; urgency=medium

  [ Samuel Thibault ]
  * New upstream snapshot.
    - patches/boot-64b: Upstreamed.
    - patches/boot-script-ld-so: Upstreamed.
    - patches/git-bool: Upstreamed.
    - patches/git-dde-pci_enable_device_mem: Upstreamed.
    - patches/git-fifo-multiple-readers: Upstreamed.
    - patches/git-libstore-file-512b-block: Upstreamed.
    - patches/git-rumpdisk-ktype: Upstreamed.
    - patches/proc-pset: Upstreamed.

  [ Mike Kelly ]
  * DDE support for APIC GSIs

 -- Samuel Thibault <sthibault@debian.org>  Wed, 29 Oct 2025 17:58:41 +0000

=== debian/control ===
Source: hurd
Section: admin
Priority: required
Maintainer: GNU Hurd Maintainers <debian-hurd@lists.debian.org>
Standards-Version: 4.6.0
Build-Depends:
 texinfo,
 debhelper-compat (= 12), dpkg-dev (>= 1.17.14), dh-exec (>= 0.17),
 gawk, flex, bison,
Build-Depends-Arch:
 mig-for-host (>= 1.8+git20231217~) <!stage1 !stage2>,
 gnumach-dev (>= 2:1.8+git20231217~) <!stage1>,
 libc0.3-dev (>= 2.33-2~1) <!stage1>,
 libcrypt-dev <!stage1 !stage2>,
 libgcrypt20-dev (>= 1.11.0~) <!stage1 !stage2>,
 libncurses-dev <!stage1 !stage2>,
 libparted-dev <!stage1 !stage2>,
 librumpdev-disk-dev (>= 0~20211031-2) <!stage1 !stage2>,
 librumpdev-if-dev <!stage1 !stage2>,
 librumpnet-dev <!stage1 !stage2>,
 librumpdev-usb-dev <!stage1 !stage2>,
 libacpica-dev <!stage1 !stage2>,
 libpciaccess-dev <!stage1 !stage2>,
 libtirpc-dev <!stage1 !stage2>,
 libxkbcommon-dev <!stage1 !stage2>,
 x11proto-core-dev <!stage1 !stage2>,
 pkgconf <!stage1 !stage2>,
 libdaemon-dev <!stage1 !stage2>,
 libpcap0.8-dev <!stage1 !stage2>,
 zlib1g-dev <!stage1 !stage2>,
 libbz2-dev <!stage1 !stage2>,
 uuid-dev <!stage1 !stage2>,
 libblkid-dev <!stage1 !stage2>,
 liblwip-dev <!stage1 !stage2>
Uploaders: Michael Banck <mbanck@debian.org>,
 Samuel Thibault <sthibault@debian.org>
Homepage: https://www.gnu.org/software/hurd/hurd.html
Vcs-Browser: https://salsa.debian.org/hurd-team/hurd
Vcs-Git: https://salsa.debian.org/hurd-team/hurd.git

Package: hurd-libs0.3
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: netdde (<< 0.0.20200330-8~)
Architecture: hurd-any
Build-Profiles: <!stage1>
Multi-Arch: same
Description: GNU Hurd (libraries)
 This package contains the libraries used by GNU Hurd.

Package: hurd
Essential: yes
Pre-Depends: hurd-libs0.3, ${misc:Pre-Depends}
Depends: ${misc:Depends}, hurd-libs0.3 (= ${binary:Version}), sysv-rc <!stage2> | openrc <!stage2>, ${shlibs:Depends}, xkb-data <!stage2>, less, passwd
Breaks: gnumach-image-1-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1-xen-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-486-dbg (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-xen-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-xen-486-dbg (<< 2:1.8+git20210809-1~),
	libc0.3 (<< 2.31-13+hurd.1~), netdde (<< 0.0.20121127-2),
	usrmerge (<< 33),
	grub-common (<< 2.06-13+hurd.2),
	makedev, login (<< 1:4.0.14-4), console-driver-xkb
Provides: makedev, login, console-driver-xkb, mount
Replaces: makedev, login (<< 1:4.0.14-4), random-egd, console-driver-xkb, initscripts (<< 2.95-4A)
Built-Using: ${built-using}
Static-Built-Using: ${built-using}
Suggests: hurd-doc
Recommends: bf-utf-source, netdde (>= 0.0.20120518~) <!stage2>
Architecture: hurd-any
Build-Profiles: <!stage1>
Description: GNU Hurd
 This is the GNU Hurd package. It contains essential system software and
 libraries.

Package: hurd-prof
Priority: optional
Pre-Depends: hurd-libs0.3
Depends: ${misc:Depends}, hurd-libs0.3 (= ${binary:Version}), ${shlibs:Depends}, xkb-data <!stage2>
Breaks: gnumach (<< 2:1.3.99.dfsg.cvs20070526-1), libc0.3 (<< 2.19-15~), netdde (<< 0.0.20121127-2)
Built-Using: ${built-using}
Static-Built-Using: ${built-using}
Suggests: hurd-doc
Recommends: bf-utf-source
Architecture: hurd-any
Build-Profiles: <!stage1 !stage2 !pkg.hurd.noprof>
Description: GNU Hurd
 This is the GNU Hurd package. It contains essential system software and
 libraries, with gprof profiling enabled.

Package: hurd-dev
Priority: standard
Section: libdevel
Architecture: hurd-any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends},
 libc0.3-dev (>= 2.13-31~) <!stage1>,
 hurd-libs0.3 (= ${binary:Version}) <!stage1>,
Provides: hurd-headers-dev, libihash-dev, libdde-linux26-dev <!stage2>
Replaces: hurd (<< 20130226-2~), hurd-headers-dev, libihash-dev
Breaks: hurd (<< 20130226-2~), hurd-headers-dev, libihash-dev
Conflicts: pslib-dev
Build-Profiles: <!stage1>
Description: GNU Hurd (development files)
 This package includes the header files and the static libraries.

Package: hurd-headers-dev
Priority: standard
Section: libdevel
Architecture: hurd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Build-Profiles: <stage1>
Description: GNU Hurd (development files)
 This package includes the header files and the static libraries.
 .
 This package is only used for bootstrap, it contains headers needed for libc

Package: hurd-doc
Priority: optional
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: www-browser
Description: GNU Hurd manual
 This package includes the manual in info and HTML format.

Package: hurd-libs0.3-udeb
Section: debian-installer
Package-Type: udeb
Priority: optional
Architecture: hurd-any
Build-Profiles: <!noudeb !stage1 !stage2>
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GNU Hurd (libraries) - udeb
 This package contains the libraries used by GNU Hurd udeb.

Package: hurd-udeb
Package-Type: udeb
Priority: optional
Section: debian-installer
Architecture: hurd-any
Build-Profiles: <!noudeb !stage1 !stage2>
Depends: ${misc:Depends}, ${shlibs:Depends}, hurd-libs0.3-udeb (= ${binary:Version}), xkb-data-udeb
Built-Using: ${built-using}
Static-Built-Using: ${built-using}
Provides: hurd, ext2-modules, fat-modules, ipv6-modules, isofs-modules, loop-modules, mouse-modules, nfs-modules, socket-modules
Description: GNU Hurd - udeb
 This is the GNU Hurd udeb package. It contains essential system software and
 libraries.
